var u1 = (this && this.u1) || function (m2, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.v1 === "function")
        r = Reflect.v1(m2, target, key, desc);
    else
        for (var n2 = m2.length - 1; n2 >= 0; n2--)
            if (d = m2[n2])
                r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import PLVLogger from '../modules/log/PLVLogger';
import PLVUtils from './PLVUtils';
export class PLVStateData {
    constructor(data) {
        this.data = data;
    }
    copy() {
        return this.copyValue(this.data);
    }
    copyValue(data) {
        return new PLVStateData(data);
    }
}
export class PLVDisposable {
    constructor() {
        this._dispose = false;
    }
    isDispose() {
        return this._dispose;
    }
    dispose() {
        this._dispose = true;
    }
}
export class PLVPromiseValue {
    set(value) {
        if (this.value == undefined) {
            this.resolve?.(value);
        }
        this.value = value;
    }
    get() {
        if (!this.promise) {
            this.promise = PLVUtils.safePromise((k2, l2) => {
                this.resolve = k2;
                if (this.value != undefined) {
                    k2(this.value);
                }
            });
        }
        return this.promise;
    }
}
let PLVLazyValue = class PLVLazyValue {
    constructor(i2) {
        this._callback = i2;
    }
    get(param) {
        if (this._value == undefined) {
            this._value = this._callback(param);
        }
        return this._value;
    }
};
PLVLazyValue = u1([
    Observed
], PLVLazyValue);
export { PLVLazyValue };
let PLVAsyncLazyValue = class PLVAsyncLazyValue {
    constructor(h2) {
        this._callback = h2;
    }
    get(callback, param) {
        if (this._value === undefined) {
            this._callback(param, (value) => {
                this._value = value;
                callback(this._value);
            });
        }
        else {
            callback(this._value);
        }
    }
};
PLVAsyncLazyValue = u1([
    Observed
], PLVAsyncLazyValue);
export { PLVAsyncLazyValue };
export class PLVEventNotify {
    constructor(e2, f2 = true) {
        this.tag = '[PLVEventNotify]';
        this.events = new Map();
        this.emitLogToFile = true;
        this.tag = PLVUtils.getClassTag(e2) || this.tag;
        this.emitLogToFile = f2;
    }
    on(event, callback, c2) {
        PLVLogger.info(PLVUtils.getClassTag(c2) || this.tag, `on event: ${event}`);
        const d2 = this.events.get(event) || [];
        d2.push(callback);
        this.events.set(event, d2);
    }
    off(event, callback, a2) {
        PLVLogger.info(PLVUtils.getClassTag(a2) || this.tag, `off event: ${event}`);
        if (callback) {
            const b2 = this.events.get(event) || [];
            const index = b2.indexOf(callback);
            if (index !== -1) {
                b2.splice(index, 1);
            }
            this.events.set(event, b2);
        }
        else {
            this.events.delete(event);
        }
    }
    emit(event, ...args) {
        PLVLogger.info(this.tag, `emit event: ${event}, args: ${args}`, this.emitLogToFile);
        const w1 = this.events.get(event) || [];
        w1.forEach(callback => {
            callback(...args);
        });
    }
    clear() {
        PLVLogger.info(this.tag, `clear event notify`);
        this.events.clear();
    }
}
