export class PLVTextUtils {
    static checkValidDataLength(...str) {
        for (const s of str) {
            if (s.length == 0) {
                return false;
            }
        }
        return true;
    }
    static parseString(input) {
        if (!(input = PLVTextUtils.convertSpecialString(input))) {
            return undefined;
        }
        const g4 = /\[([^\[\]]{1,5})\]/g;
        let match;
        let h4 = 0;
        const result = [];
        while ((match = g4.exec(input)) !== null) {
            const j4 = match[0];
            if (match.index > h4) {
                const k4 = input.slice(h4, match.index);
                result.push(k4);
            }
            result.push(j4);
            h4 = g4.lastIndex;
        }
        if (h4 < input.length) {
            const i4 = input.slice(h4);
            result.push(i4);
        }
        return result;
    }
    static convertSpecialString(input) {
        return input?.replace(/&lt;/g, "<")
            .replace(/&lt/g, "<")
            .replace(/&gt;/g, ">")
            .replace(/&gt/g, ">")
            .replace(/&yen;/g, "¥")
            .replace(/&yen/g, "¥")
            .replace(/&quot;/g, "\"")
            .replace(/&nbsp;/g, " ")
            .replace(/&#39;/g, "'")
            .replace(/&amp;/g, "&");
    }
    static toString(num) {
        return (num || num == 0) ? num + '' : undefined;
    }
    static toWString(data) {
        if (data && data > 10000) {
            return (data / 10000).toFixed(1) + 'w';
        }
        return PLVTextUtils.toString(data);
    }
    static fixPic(f4) {
        if (!f4) {
            return f4 || '';
        }
        if (f4.startsWith('//')) {
            return `http:${f4}`;
        }
        else if (f4.startsWith('/')) {
            return `http://livestatic.videocc.net${f4}`;
        }
        return f4;
    }
    static isNumberZero(number) {
        if (!number) {
            return true;
        }
        const e4 = parseFloat(number);
        return e4 === 0;
    }
}
