import worker from '@ohos.worker';
import { FilePrinter } from '@ohos-port/xlog';
import { LogAddMessage, LogInitMessage } from '@ohos-port/xlog/src/main/ets/printer/file/MessageType';
import { Printer } from '@ohos-port/xlog/src/main/ets/printer/Printer';
export class PLVXLogFilePrinter extends Printer {
    constructor(builder) {
        super();
        this.builder = builder;
        if (this.builder.useWorker) {
            try {
                this.workerInstance = new worker.ThreadWorker(this.builder.workerPath);
                this.workerInstance.onmessage = (e) => {
                    let data = e.data;
                    let type = data.type;
                };
                this.workerInstance.onexit = (code) => {
                };
                let data = new LogInitMessage(this.builder);
                this.workerInstance.postMessage(data);
            }
            catch (err) {
            }
        }
    }
    println(b7, tag, msg) {
        if (this.workerInstance != null) {
            let data = new LogAddMessage(b7, tag, msg);
            this.workerInstance.postMessage(data);
        }
    }
}
export class PLVXLogBuilder extends FilePrinter.Builder {
    build() {
        super.build();
        return new PLVXLogFilePrinter(this);
    }
}
