import buffer from "@ohos.buffer";
import { CryptoJS } from '@ohos/crypto-js';
export class PLVRequestSetting {
    static createSign(map, key) {
        const a8 = key + PLVRequestSetting.concatParams(map) + key;
        const b8 = CryptoJS.MD5(a8).toString().toUpperCase();
        return b8;
    }
    static decryptDataSync(data) {
        const z7 = CryptoJS.AES.decrypt(buffer.from(data, 'base64').toString('hex'), CryptoJS.enc.Utf8.parse(PLVRequestSetting.DECRYPT_KEY_1_SRC), {
            format: CryptoJS.format.Hex,
            iv: CryptoJS.enc.Utf8.parse(PLVRequestSetting.DECRYPT_KEY_2_SRC),
            mode: CryptoJS.mode.CBC,
            padding: CryptoJS.pad.Pkcs7
        }).toString(CryptoJS.enc.Utf8);
        return z7;
    }
    static concatParams(map) {
        const y7 = Array.from(map.keys()).sort();
        const builder = [];
        for (const key of y7) {
            if (!key || !map.get(key)) {
                continue;
            }
            builder.push(key + map.get(key));
        }
        return builder.join('');
    }
}
PLVRequestSetting.KEY_1 = 'polyv_sdk_api_innor';
PLVRequestSetting.PLV_SWITCH_API_INNOR = 'polyv_switch_api_innor';
PLVRequestSetting.DECRYPT_KEY_1_SRC = 'PolyvApiResponse';
PLVRequestSetting.DECRYPT_KEY_2_SRC = 'PolyvLiveEncrypt';
